function $(id)
{
  return document.getElementById(id);
}

function replaceAll(texte, recherche, remplacement)
{
  while (texte.indexOf(recherche) != -1)
    texte = texte.replace(recherche, remplacement);
  return texte;
}

function initPre()
{
  var pre = "";
  var indentation = 0;
  var media = false;
  for (var i = 0; i < css.length; i++) {
    var ligne = css[i];
    // Fermeture de } :
    if (indentation > 0 && ligne.indexOf("}") != -1) {
      indentation--;
      if (indentation == 0)
        media = false;
    }
    pre += "<label>";
    // Ajout d'une case à cocher si nécessaire :
    if (indentation > (media ? 1 : 0))
      pre += "<input type='checkbox' id='case-" + i + "' checked='checked' onclick='valider()'>";
    // Ouverture de { :
    if (ligne.indexOf("{") != -1) {
      indentation++;
      if (indentation == 1 && ligne.indexOf("@media") != -1)
        media = true;
    }
    // Pour IE, qui n'afficherait pas les lignes vides, et qui réduit les espaces en un seul :
    if (ligne == "")
      ligne = "&nbsp;";
    ligne = replaceAll(ligne, " ", "&nbsp;");
    // Coloration syntaxique basique de la ligne :
    if (indentation > (media ? 1 : 0)) // "#menu a:active" n'est pas une propriété !
      ligne = ligne.replace(new RegExp("(^[^:\\/]+:)", "g"), "<span class='propriete'>$1</span>");
    ligne = ligne.replace(new RegExp("(\\/\\*.+\\*\\/)", "g"), "<span class='commentaire'>$1</span>");
    // Ajout de la ligne :
    pre += ligne + "</label>" + "<br>";
  }
  $("edition").innerHTML = pre;
  calculerCSS();
}

function valider()
{
  calculerCSS();


  $("appercu").contentWindow.location.reload();


/*
  var html =
    "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">\n" +
    "<html lang=\"fr\">\n" +
    "  <head>\n" +
    "    <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n" +
    "    <title>Catalogue des bateaux - Maquettes Casey Steven & Son</title>\n" +

    "    <style type=\"text/css\">\n" +
           getCSS() +
    "    </style>\n" +

    "    <script type=\"text/javascript\">\n" +
    "      var grandContenu = \"\";\n" +
    "\n" +
    "      function retrecirPage()\n" +
    "      {\n" +
    "        grandContenu = document.getElementById(\"contenu\").innerHTML;\n" +
    "        document.getElementById(\"contenu\").innerHTML =\n" +
    "          \"<p>Le contenu de la page est maintenant moins haut que le menu. \" +\n" +
    "          \"Je vous suggère de désactiver et réactiver la ligne \"clear: both;\" dans la règle #pied pour tester son effet.<br>\" +\n" +
    "          \"<a href='#' onclick='return agrandirPage();'>Faire en sorte que la page soit plus haute que le menu</a>.</p>\";\n" +
    "        parent.menuPlusHautQuePage = true;\n" +
    "        return false;\n" +
    "      }\n" +
    "\n" +
    "      function agrandirPage()\n" +
    "      {\n" +
    "        document.getElementById(\"contenu\").innerHTML = grandContenu;\n" +
    "        parent.menuPlusHautQuePage = false;\n" +
    "        return false;\n" +
    "      }\n" +
    "    </script>\n" +
    "    <!--[if lt IE 8]><link rel=\"stylesheet\" type=\"text/css\" href=\"ie.css\"><![endif]-->\n" +
    "  </head>\n" +
    "  <body>\n" +
    "\n" +
    "    <!-- L'entête de la page, affiché tout en haut de l'écran : -->\n" +
    "    <div id=\"entete\">\n" +
    "      <h1>Maquettes Casey Steven & Son MODIFIE</h1>\n" +
    "\n" +
    "      <!-- Le menu principal du site, affiché horizontalement, tout en haut de l'écran, juste en dessous de l'entête : -->\n" +
    "      <ul id=\"menu\">\n" +
    "        <li><a href=\"#\"><span>Accueil</span></a></li>\n" +
    "        <li><a href=\"#\" class=\"actuel\"><span>Catalogue</span></a></li>\n" +
    "        <li><a href=\"#\"><span>Espace clients</span></a></li>\n" +
    "        <li><a href=\"#\"><span>Newsletter</span></a></li>\n" +
    "        <li><a href=\"#\"><span>...</span></a></li>\n" +
    "      </ul>\n" +
    "    </div>\n" +
    "\n" +
    "    <!-- La page en elle-même, cette division sera utile pour styler le site en CSS : -->\n" +
    "    <div id=\"page\">\n" +
    "      <!-- Le sous-menu, affiché dans une colonne sur la gauche du site : -->\n" +
    "      <ul id=\"sous-menu\">\n" +
    "        <li><a href=\"#\">Avions</a></li>\n" +
    "        <li><a href=\"#\" class=\"actuel\">Bateaux</a></li>\n" +
    "        <li><a href=\"#\">Camions</a></li>\n" +
    "        <li><a href=\"#\">Divers</a></li>\n" +
    "        <li><a href=\"#\">Hélicoptères</a></li>\n" +
    "        <li><a href=\"#\">Militaires</a></li>\n" +
    "        <li><a href=\"#\">Motos</a></li>\n" +
    "        <li><a href=\"#\">Voitures</a></li>\n" +
    "        <li><a href=\"#\">...</a></li>\n" +
    "      </ul>\n" +
    "      \n" +
    "      <!-- Le contenu utile de la page, affiché sur une grande colonne à droite du site : -->\n" +
    "      <div id=\"contenu\">\n" +
    "        <h2>Catalogue des bateaux</h2>\n" +
    "        \n" +
    "        <h3>Les bateaux qui flottent</h3>\n" +
    "        <p>\n" +
    "          Le contenu de la page est plus haut que le menu de gauche.\n" +
    "          Je vous suggère de désactiver et réactiver la ligne \"background: ...\" dans la règle #page, ainsi que la ligne \"margin: ...\" dans la règle #contenu, pour tester leurs effets.<br>\n" +
    "          <a href=\"#\" onclick=\"return retrecirPage();\">Faire en sorte que le menu soit plus haut que la page</a>.\n" +
    "        </p>\n" +
    "\n" +
    "        <p>\n" +
    "          Integer fermentum vulputate dolor. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Aenean elementum enim et massa. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Nullam euismod pretium mi. Aliquam vitae lacus vitae nisi commodo dictum. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Curabitur sit amet dui. Suspendisse congue, risus eu fermentum cursus, neque sapien aliquet orci, vel lobortis felis tellus et nibh. Donec id leo. In quis nisi eget nunc scelerisque venenatis. Aenean porta. Fusce interdum tellus ac urna.\n" +
    "        </p>\n" +
    "      </div>\n" +
    "\n" +
    "      <!-- Le pied de page, affiché tout en bas de l'écran. Est à l'intérieur du div \"page\" pour le CSS : -->\n" +
    "      <div id=\"pied\">\n" +
    "        © 2007 Sébastien Laoût<br>\n" +
    "        Cette maquette de site sert d'illustration à\n" +
    "        <a href=\"http://slaout.linux62.org/html_css/maquette.html\">la page Maquette du Tutoriel HTML & CSS</a>\n" +
    "        de Sébastien Laoût.\n" +
    "      </div>\n" +
    "    </div>\n" +
    "\n" +
    "    <script type=\"text/javascript\">\n" +
    "      if (parent.menuPlusHautQuePage)\n" +
    "        retrecirPage();\n" +
    "    </script>\n" +
    "\n" +
    "  </body>\n" +
    "</html>\n"
  ;
  $("appercu").contentWindow.document.documentElement.innerHTML = html;*/
}

var menuPlusHautQuePage = false;

var resultat;

function calculerCSS()
{
  resultat = "";
  for (var i = 0; i < css.length; i++) {
    var ligne = css[i];
    var coche = $("case-" + i);
    if (!coche || coche.checked)
      resultat += ligne + "\n";
  }
  return resultat;
}

function getCSS()
{
  return resultat;
}

function aide()
{
  $("dialogue").style.display = "block";
  $("aide").style.display = "block";

  return false;
}

function cocherTout()
{
  for (var i = 0; i < css.length; i++) {
    var coche = $("case-" + i);
    if (coche)
      coche.checked = true;
  }
  valider();
  return false;
}

function decocherTout()
{
  for (var i = 0; i < css.length; i++) {
    var coche = $("case-" + i);
    if (coche)
      coche.checked = false;
  }
  valider();
  return false;
}

function afficherSourceHtml()
{
  $("dialogue").style.display = "block";
  $("source-html").style.display = "block";

  return false;
}

function cacherSourceHtml()
{
  $("dialogue").style.display = "none";
  $("source-html").style.display = "none";
  $("aide").style.display = "none";

  return false;
}
